Imports System.Drawing.Drawing2D
Public Class FarbLabel
    Inherits System.Windows.Forms.Label
    'Dies ist eine vom Label abgeleitete Klasse, farbige Labels 
    '(mit einem Gradienten im Hintergrund) darzustellen

    Private m_BMP As Bitmap = Nothing

    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        Dim Rect As New Rectangle(0, 0, Me.Width, Me.Height)
        'Benutzerdefinierten Zeichnungscode hier einfgen
        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height)
            Dim g As Graphics = Graphics.FromImage(m_BMP)
            Dim BackBrush As New LinearGradientBrush(Rect, Me.ForeColor, Me.BackColor, 115.0F)
            g.FillRectangle(BackBrush, Rect)
            Using ForeBrush As New SolidBrush(Me.ForeColor)
                g.DrawString(Me.Text, Me.Font, ForeBrush, 2, 2)
            End Using

        End If
        pe.Graphics.DrawImage(m_BMP, Rect)
    End Sub


    Public Sub New()
        Me.SetStyle(ControlStyles.DoubleBuffer Or ControlStyles.UserPaint Or ControlStyles.AllPaintingInWmPaint, True)
    End Sub
    Protected Overrides Sub OnAutoSizeChanged(ByVal e As System.EventArgs)
        If Me.AutoSize Then
            Me.AutoSize = False
        End If
    End Sub

#Region " Ereignisse, die zur nderung des Aussehens dieses Controls fhren "
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)
        m_BMP = Nothing
        Invalidate()
    End Sub
    Private Sub FarbLabel_BackColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.BackColorChanged
        m_BMP = Nothing
        Invalidate()
    End Sub
    Private Sub FarbLabel_ForeColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ForeColorChanged
        m_BMP = Nothing
        Invalidate()
    End Sub
    Private Sub DescriptionLabel_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.TextChanged
        m_BMP = Nothing
        Invalidate()
    End Sub
#End Region

End Class
