Imports Microsoft.VisualBasic.ApplicationServices
Imports System.Collections.ObjectModel
Namespace My
    Partial Friend Class MyApplication

        'Class MultiSDIApplication
        Inherits WindowsFormsApplicationBase

        Private Shared m_application As MyApplication
        Friend Shared ReadOnly Property Application() As MyApplication
            Get
                If m_application Is Nothing Then
                    m_application = New MyApplication()
                End If
                Return m_application
            End Get
        End Property

        Public Sub New()
            MyBase.New(Global.Microsoft.VisualBasic.ApplicationServices.AuthenticationMode.Windows)

            ' damit wird als Applikations-Basis ein Single-SDI Framework verwendet, 
            ' und das Event OnStartupNextInstance geliefert
            Me.IsSingleInstance = True
            Me.EnableVisualStyles = True
            Me.SaveMySettingsOnExit = True

            ' wird fr Multi-SDI gebraucht, hier sind mehrere MainForms vorhanden
            Me.ShutdownStyle = Global.Microsoft.VisualBasic.ApplicationServices.ShutdownMode.AfterAllFormsClose

        End Sub

        'Erstellt die erste Top-Level Form
        Protected Overrides Sub OnCreateMainForm()
            Me.MainForm = Me.CreateTopLevelWindow(Me.CommandLineArgs)
        End Sub

        Function CreateTopLevelWindow(ByVal args As ReadOnlyCollection(Of String)) As frm_Main
            'Herstellen einer Verknpfung zwischen Anwendungs-Icon und Datei-Extension
            Dim AD As New Anwendungsdaten
            AD.Icon_Verknpfung_herstellen()

            Dim StartPfad As String = ""
            Dim CommandLine As String = ""
            For Each txt As String In args
                CommandLine &= " " & txt
            Next
            CommandLine = CommandLine.Trim


            If CommandLine.IndexOf("/open/") > -1 Then
                StartPfad = AD.GetLongFilename(CommandLine.Substring(0, CommandLine.IndexOf("/open/")))
            End If

            ' Neue Top-Level Form erstellen 
            Return frm_Main.CreateTopLevelWindow(StartPfad)

        End Function

        Protected Overrides Sub OnStartupNextInstance(ByVal eventArgs As Microsoft.VisualBasic.ApplicationServices.StartupNextInstanceEventArgs)
            Me.CreateTopLevelWindow(eventArgs.CommandLine)
        End Sub

        Public Sub AddTopLevelForm(ByVal form As Form)

            ' Die Form zur forms-collection hinzufgen und
            ' auf Ereignisse zum Aktivieren und Schliessen warten
            AddHandler form.Activated, AddressOf Form_Activated
            AddHandler form.FormClosed, AddressOf Form_FormClosed

            If Me.OpenForms.Count = 1 Then
                Me.MainForm = form
            End If

        End Sub

        Sub Form_Activated(ByVal sender As Object, ByVal e As EventArgs)
            Me.MainForm = CType(sender, Form)
        End Sub


        Sub Form_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs)

            Dim frm As Form = CType(sender, Form)
            If frm Is Me.MainForm AndAlso Me.OpenForms.Count > 0 Then
                Me.MainForm = CType(Me.OpenForms(0), Form)
            End If

            RemoveHandler frm.Activated, AddressOf Form_Activated
            RemoveHandler frm.FormClosed, AddressOf Form_FormClosed

        End Sub

        Public Sub AddWindowMenu(ByVal windowMenu As ToolStripMenuItem)
            'Das "Fenster"-Men zeigt alle geffneten Anwendungsfenster an.
            'Dieser Handler ermglicht das Wechseln zwischen geffneten Fenstern
            AddHandler windowMenu.DropDownOpening, AddressOf windowMenu_DropDownOpening
        End Sub


        Sub windowMenu_DropDownOpening(ByVal sender As Object, ByVal e As EventArgs)
            Dim menu As ToolStripMenuItem = CType(sender, ToolStripMenuItem)

            ' Das aktuelle Men bereinigen
            If menu.DropDownItems.Count > 0 Then
                menu.DropDownItems.Clear()
            End If


            ' Diese Men enthlt je ein Item fr jedes offene frm_Main

            For Each frm As Form In Me.OpenForms
                If TypeOf (frm) Is frm_Main Then
                    Dim item As New ToolStripMenuItem()
                    item.Text = frm.Text
                    item.Tag = frm
                    menu.DropDownItems.Add(item)
                    AddHandler item.Click, AddressOf WindowMenuItem_Click

                    ' Markieren des Menitems, das das aktuelle Fenster reprsentiert
                    If frm Is Me.MainForm Then
                        item.Checked = True
                    End If
                End If
            Next

        End Sub


        Sub WindowMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
            ' Top-Level-Form abhngig von der Auswahl aktivieren
            CType(CType(sender, ToolStripMenuItem).Tag, Form).Activate()
        End Sub
    End Class



End Namespace


