Imports System.Xml
Public Class Personenliste
    Inherits List(Of Person)
    'Die Personenliste spiegelt so etwas wie eine Datei wieder
    'Sie enthlt eine Liste aus Personen, die bei Angabe eines 
    'Pfades als XML-Datei gespeichert und wieder gelesen werden kann.


#Region " Private Variablen "
    'Pfad zum Speichern
    Private m_Pfad As String = ""
    'Info, ob an der Datei nderungen vorgenommen wurden
    Private m_Geaendert As Boolean = False
#End Region

#Region " Properties "
    Property Pfad() As String
        Get
            Return m_Pfad
        End Get
        Set(ByVal value As String)
            m_Pfad = value
        End Set
    End Property
    Property Geaendert() As Boolean
        Get
            Return m_Geaendert
        End Get
        Set(ByVal value As Boolean)
            m_Geaendert = value
        End Set
    End Property
#End Region

#Region " Constructor "
    Public Sub New()
        'Erstellen einer komplett neuen Personenliste
        '(der Pfad wird beim Speichern erstellt)
    End Sub

    Public Sub New(ByVal Pfad As String)
        'ffnen einer existierenden Personenliste
        m_Pfad = Pfad
        XML_Lesen()
    End Sub
#End Region

#Region " XML lesen und schreiben "
    Private Sub XML_Lesen()
        Dim reader As New XmlTextReader(m_Pfad)

        reader.WhitespaceHandling = WhitespaceHandling.None
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(reader)
        reader.Close()

        Dim xnod As XmlNode = xmlDoc.DocumentElement

        For Each xKn As XmlNode In xnod.ChildNodes
            If xKn.Name = "Person" Then
                Me.Add(New Person(xKn.Attributes("Nachname").Value, xKn.Attributes("Vorname").Value, CBool(xKn.Attributes("maennlich").Value)))
            End If
        Next
    End Sub
    Public Sub Speichern()
        'XML Schreiben
        If Not m_Geaendert Then Exit Sub

        Dim writer As XmlTextWriter = New XmlTextWriter(m_Pfad, System.Text.Encoding.UTF8)
        writer.WriteStartDocument(True)

        writer.WriteStartElement("Elemente")

        For Each Pers As Person In Me
            writer.WriteStartElement("Person")
            writer.WriteAttributeString("Nachname", Pers.Nachname)
            writer.WriteAttributeString("Vorname", Pers.Vorname)
            writer.WriteAttributeString("maennlich", Pers.Maennlich.ToString)
            writer.WriteEndElement()
        Next

        writer.WriteEndElement()
        writer.WriteEndDocument()
        writer.Close()

        m_Geaendert = False
    End Sub
#End Region

End Class
