Public Class Command_ListView_Sortieren
    Inherits Command

    Private m_Frm As frm_Main
    Private m_OldItems As List(Of PersonListViewItem)
    Private m_NewItems As List(Of PersonListViewItem)
    Private m_SortierArt As PersonSortierArten
    Private m_LVI As PersonListViewItem

    ReadOnly Property SortierArt() As PersonSortierArten
        Get
            Return m_SortierArt
        End Get
    End Property


    Public Sub New(ByVal SortierArt As PersonSortierArten, ByVal Frm As frm_Main)
        m_Frm = Frm
        If m_Frm.ListView1.SelectedItems.Count > 0 Then
            m_LVI = m_Frm.ListView1.SelectedItems(0)
        End If
        m_SortierArt = SortierArt
    End Sub


    Public Overrides ReadOnly Property Name() As String
        Get
            Return "ListView sortieren"
        End Get
    End Property

    Public Overrides Sub DoAction()
        m_OldItems = New List(Of PersonListViewItem)
        m_NewItems = New List(Of PersonListViewItem)
        For Each Itm As PersonListViewItem In m_Frm.ListView1.Items
            m_OldItems.Add(Itm)
            m_NewItems.Add(Itm)
        Next
        m_NewItems.Sort(New PersonLVIComparer(m_SortierArt))
        Sortierung_Anzeigen(m_NewItems)
    End Sub
    Private Sub Sortierung_Anzeigen(ByVal Items As List(Of PersonListViewItem))
        m_Frm.Moving = True

        m_Frm.ListView1.Items.Clear()
        m_Frm.Personen.Clear()

        For Each LVI As PersonListViewItem In Items
            m_Frm.ListView1.Items.Add(LVI)
            m_Frm.Personen.Add(LVI.Person)
        Next
        m_Frm.ListViewAenderung()

        If m_LVI IsNot Nothing Then
            m_LVI.Selected = True
        End If

        m_Frm.Personen.Geaendert = True
        m_Frm.Moving = False
        m_Frm.AktuellePerson_Lesen()
    End Sub


    Public Overrides Sub RedoAction()
        Sortierung_Anzeigen(m_NewItems)
    End Sub

    Public Overrides Sub UndoAction()
        Sortierung_Anzeigen(m_OldItems)
    End Sub
    Public Overrides ReadOnly Property IsNoop() As Boolean
        Get
            Return False
        End Get
    End Property

    Private Class PersonLVIComparer
        Implements IComparer(Of PersonListViewItem)
        'IComparer ist ein Interface, das das Sortieren von Listen mit Objekten 
        'sehr bequem macht.
        'Mit der Funktion Compare kann man selbst definieren,
        'wie zwei Objekte untereinander verglichen werden sollen

        Private m_SortierArt As PersonSortierArten
        Public Sub New(ByVal SortierArt As PersonSortierArten)
            m_SortierArt = SortierArt
        End Sub

        Public Function Compare(ByVal x As PersonListViewItem, ByVal y As PersonListViewItem) As Integer Implements System.Collections.Generic.IComparer(Of PersonListViewItem).Compare
            Dim A, B As Person
            If (m_SortierArt = PersonSortierArten.NachnameAbsteigend) Or (m_SortierArt = PersonSortierArten.VornameAbsteigend) Then
                A = y.Person
                B = x.Person
            Else
                A = x.Person
                B = y.Person
            End If

            If (m_SortierArt = PersonSortierArten.NachnameAbsteigend) Or (m_SortierArt = PersonSortierArten.NachnameAufsteigend) Then
                If A.Nachname <> B.Nachname Then
                    Return A.Nachname.CompareTo(B.Nachname)
                Else
                    Return A.Vorname.CompareTo(B.Vorname)
                End If
            Else
                If A.Vorname <> B.Vorname Then
                    Return A.Vorname.CompareTo(B.Vorname)
                Else
                    Return A.Nachname.CompareTo(B.Nachname)
                End If
            End If

        End Function
    End Class


End Class
