Imports System.Collections.ObjectModel
Public Class frm_Main

#Region " Private Variablen "
    'Die Liste, die Personen enthlt und als XML-Datei gespeichert werden
    'kann
    Private m_Personen As Personenliste

    'Die Varible TextBoxAktualisierung ist immer beim Wechsel von einer 
    'Person zur nchsten (und damit bei nderungen der Text-Box-Inhalte 
    'fr Nachanme, Vorname...) True
    Private TextBoxAktualisierung As Boolean = False

    'Variablen, die den Sortier-Zustand im ListView festhalten
    'Private ListeIst_Nachname_AbstSortiert As Boolean = False
    'Private ListeIst_Vorname_AbstSortiert As Boolean = False
    Private m_AktuelleSortierung As PersonSortierArten = PersonSortierArten.unsortiert

    'Die Variable m_Moving ist True, wenn nur Elemente im ListView
    'verschoben werden (Dann brauchen Inhalte der TextBoxen nicht 
    'aktualisiert werden)
    Private m_Moving As Boolean = False

    Private WithEvents m_undoManager As UndoManager
#End Region

#Region " Oeffentliche Variablen "
    ReadOnly Property Personen() As Personenliste
        Get
            Return m_Personen
        End Get
    End Property
#End Region

#Region " Start "
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Icon = My.Resources.Personensammlung
        Me.ImageList1.Images.Add(My.Resources.Mann)
        Me.ImageList1.Images.Add(My.Resources.Frau)
    End Sub
#End Region

#Region " ListView neu fllen / Sortieren "

    Private Sub Personenliste_Lesen()
        'Neuauffllung des ListView
        Me.ListView1.Items.Clear()

        For Each P As Person In m_Personen
            Me.ListView1.Items.Add(New PersonListViewItem(P))
        Next
        ListViewAenderung()
    End Sub


    Private Sub ListView1_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles ListView1.ColumnClick
        'Sortieren der Elemente im ListView (und der Datei)
        'bei Klick auf einen ColumnHeader

        If m_Personen.Count = 0 Then Exit Sub

        'm_AktuelleSortierung
        Dim NeueSortierung As PersonSortierArten = GetNeueSortierung(e.Column)

        Dim Gefunden As Boolean = False
        Dim xcmd As Command = m_undoManager.Peek
        If xcmd IsNot Nothing AndAlso TypeOf xcmd Is Command_ListView_Sortieren Then
            Dim cmd As Command_ListView_Sortieren = xcmd
            If cmd.SortierArt = NeueSortierung Then
                Gefunden = True
            End If
        End If
        If Not Gefunden Then
            Dim Cmd As New Command_ListView_Sortieren(NeueSortierung, Me)
            m_undoManager.Push(Cmd)
        End If

        m_AktuelleSortierung = NeueSortierung
    End Sub
    Private Function GetNeueSortierung(ByVal SelectedColumn As Integer) As PersonSortierArten
        Select Case SelectedColumn
            Case 0
                If m_AktuelleSortierung = PersonSortierArten.NachnameAbsteigend Then
                    Return PersonSortierArten.NachnameAufsteigend
                ElseIf m_AktuelleSortierung = PersonSortierArten.NachnameAufsteigend Then
                    Return PersonSortierArten.NachnameAbsteigend
                Else
                    Return PersonSortierArten.NachnameAufsteigend
                End If
            Case 1
                If m_AktuelleSortierung = PersonSortierArten.VornameAbsteigend Then
                    Return PersonSortierArten.VornameAufsteigend
                ElseIf m_AktuelleSortierung = PersonSortierArten.VornameAufsteigend Then
                    Return PersonSortierArten.VornameAbsteigend
                Else
                    Return PersonSortierArten.VornameAufsteigend
                End If
        End Select
    End Function
#End Region

#Region " nderungen im ListView "



    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        ListViewAenderung()
    End Sub

    Public Sub ListViewAenderung()
        If m_Moving AndAlso ListView1.SelectedItems.Count = 0 Then Exit Sub

        If ListView1.SelectedItems.Count = 0 Then
            Me.ButtonDelete.Enabled = False
            Me.ButtonDown.Enabled = False
            Me.ButtonUp.Enabled = False
        Else
            Me.ButtonDelete.Enabled = True
            Dim Idx As Integer = ListView1.SelectedItems(0).Index
            If Idx = 0 Then
                Me.ButtonUp.Enabled = False
            Else
                Me.ButtonUp.Enabled = True
            End If
            If Idx = ListView1.Items.Count - 1 Then
                Me.ButtonDown.Enabled = False
            Else
                Me.ButtonDown.Enabled = True
            End If
        End If
        AktuellePerson_Lesen()
    End Sub

    Public Sub AktuellePerson_Lesen()
        If m_Moving Then Exit Sub
        TextBoxAktualisierung = True
        If ListView1.SelectedItems.Count = 0 Then
            Me.TextBoxNachname.Text = ""
            Me.TextBoxVorname.Text = ""
            Me.CheckBoxMaennlich.Checked = False
            Me.TextBoxNachname.Enabled = False
            Me.TextBoxVorname.Enabled = False
            Me.CheckBoxMaennlich.Enabled = False
        Else
            Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
            Me.TextBoxNachname.Text = SelItem.Person.Nachname
            Me.TextBoxVorname.Text = SelItem.Person.Vorname
            Me.CheckBoxMaennlich.Checked = SelItem.Person.Maennlich
            Me.TextBoxNachname.Enabled = True
            Me.TextBoxVorname.Enabled = True
            Me.CheckBoxMaennlich.Enabled = True
        End If
        TextBoxAktualisierung = False
    End Sub

    Private Sub TextBoxNachname_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNachname.TextChanged
        If TextBoxAktualisierung Then Exit Sub
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)


        Dim Gefunden As Boolean = False
        Dim xcmd As Command = m_undoManager.Peek
        If xcmd IsNot Nothing AndAlso TypeOf xcmd Is Command_Nachname_Aendern Then
            Dim cmd As Command_Nachname_Aendern = xcmd
            If cmd.Person Is SelItem.Person Then
                cmd.NeuerNachname = TextBoxNachname.Text
                Gefunden = True
            End If
        End If
        If Not Gefunden Then
            Dim Cmd As New Command_Nachname_Aendern(Me, SelItem.Person, TextBoxNachname.Text)
            m_undoManager.Push(Cmd)
        End If

        m_Personen.Geaendert = True
    End Sub

    Private Sub TextBoxVorname_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxVorname.TextChanged
        If TextBoxAktualisierung Then Exit Sub
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)

        Dim Gefunden As Boolean = False
        Dim xcmd As Command = m_undoManager.Peek
        If xcmd IsNot Nothing AndAlso TypeOf xcmd Is Command_Vorname_Aendern Then
            Dim cmd As Command_Vorname_Aendern = xcmd
            If cmd.Person Is SelItem.Person Then
                cmd.NeuerVorname = TextBoxVorname.Text
                Gefunden = True
            End If
        End If
        If Not Gefunden Then
            Dim Cmd As New Command_Vorname_Aendern(Me, SelItem.Person, TextBoxVorname.Text)
            m_undoManager.Push(Cmd)
        End If

        m_Personen.Geaendert = True
    End Sub

    Private Sub CheckBoxMaennlich_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBoxMaennlich.Click
        If TextBoxAktualisierung Then Exit Sub
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)


        Dim Cmd As New Command_Geschlecht_Aendern(Me, SelItem.Person)
        m_undoManager.Push(Cmd)

        m_Personen.Geaendert = True
    End Sub
#End Region

#Region " Button-Funktionen "

    Private Sub ButtonAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAdd.Click
        Dim Cmd As New Command_NeuePersonAnlegen(Me)
        m_undoManager.Push(Cmd)
        'Dim PG As New PersonenGenerator
        'Dim PS As Person = PG.Create_Person

        'm_Personen.Add(PS)
        'm_Personen.Geaendert = True
        'Dim LVI As New PersonListViewItem(PS)
        'Me.ListView1.Items.Add(LVI)
        'LVI.Selected = True
        'LVI.EnsureVisible()
    End Sub

    Private Sub ButtonDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDelete.Click
        Dim Cmd As New Command_Person_Loeschen(Me, ListView1.SelectedItems(0))
        m_undoManager.Push(Cmd)
        'Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)
        'Dim Idx As Integer = SelItem.Index
        'm_Personen.Remove(SelItem.Person)
        'SelItem.Remove()
        'm_Personen.Geaendert = True
        ''Index um 1 vermindern
        'If Idx > 0 Then Idx -= 1
        'If m_Personen.Count > 0 Then
        '    ListView1.Items(Idx).Selected = True
        'End If
    End Sub

    Private Sub ButtonUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUp.Click
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)

        Dim Cmd As New Command_Person_NachOben(SelItem, Me)
        m_undoManager.Push(Cmd)

        m_Personen.Geaendert = True
    End Sub

    Private Sub ButtonDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDown.Click
        Dim SelItem As PersonListViewItem = ListView1.SelectedItems(0)


        Dim Cmd As New Command_Person_NachUnten(SelItem, Me)
        m_undoManager.Push(Cmd)

        m_Personen.Geaendert = True
    End Sub

    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Me.Close()
    End Sub

#End Region

#Region " Extra-Funktionen "

    Private Sub ListView1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.Resize
        'Neueinstellen der Spaltenbreiten im ListView 
        'bei ndern der ListView-Gre
        Dim Halbbreite As Integer = ListView1.Width \ 2
        ListView1.Columns(0).Width = Halbbreite
        ListView1.Columns(1).Width = -2
    End Sub

    Private Function FreienPfadFinden(ByVal DirName As String, ByVal FileName As String, ByVal Extension As String) As String
        Dim Zahl As Integer = 0

        If Not DirName.EndsWith("\") Then DirName &= "\"
        Dim ErgPfad As String = DirName & FileName & Extension

        While (IO.File.Exists(ErgPfad))
            ErgPfad = DirName & FileName & Zahl.ToString & Extension
            Zahl += 1
        End While

        Return ErgPfad
    End Function

#End Region

    Public Overridable Sub ShowStatus(ByVal msg As String)
        Me.ToolStripStatusLabelMessage.Text = msg
    End Sub

    Private Sub m_undoManager_StateChanged() Handles m_undoManager.StateChanged
        Me.ShowStatus("")
        Me.UndoToolStripButton.Enabled = m_undoManager.CanUndo
        Me.UndoToolStripMenuItem.Enabled = Me.UndoToolStripButton.Enabled

        Me.RedoToolStripButton.Enabled = m_undoManager.CanRedo
        Me.RedoToolStripMenuItem.Enabled = Me.RedoToolStripButton.Enabled

        Dim UndoText As String = "&Rckgngig "
        Dim RedoText As String = "&Wiederholen "

        Dim cmd As Command = m_undoManager.Peek()
        If cmd IsNot Nothing Then UndoText &= cmd.Name
        Me.UndoToolStripMenuItem.Text = UndoText
        'Me.UndoToolStripButton.Text = UndoText.Substring(1)

        cmd = m_undoManager.Current
        If cmd IsNot Nothing Then RedoText &= cmd.Name
        Me.RedoToolStripMenuItem.Text = RedoText
        'Me.RedoToolStripButton.Text = RedoText.Substring(1)

    End Sub

    Private Sub UndoToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UndoToolStripButton.Click, UndoToolStripMenuItem.Click
        m_undoManager.Undo()
    End Sub

    Private Sub RedoToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RedoToolStripButton.Click, RedoToolStripMenuItem.Click
        m_undoManager.Redo()
    End Sub

    Property SelectedPerson() As Person
        Get
            If ListView1.SelectedItems.Count = 0 Then
                Return Nothing
            Else
                Dim LVI As PersonListViewItem = ListView1.SelectedItems(0)
                Return LVI.Person
            End If
        End Get
        Set(ByVal value As Person)
            For Each Itm As PersonListViewItem In ListView1.Items
                If Itm.Person Is value Then
                    Itm.Selected = True
                    Exit For
                End If
            Next
        End Set
    End Property

    WriteOnly Property Moving() As Boolean
        Set(ByVal value As Boolean)
            m_Moving = value
        End Set
    End Property


#Region " Dateien speichern "
    Shared LeereDateienZahl As Integer = 0

    ReadOnly Property DateiName() As String
        Get
            Return m_Personen.Pfad
        End Get
    End Property

    Public Shared Function CreateTopLevelWindow(ByVal DateiName As String) As frm_Main

        'Diese Funtion wird in unterschiedlichen Fllen aufgerufen:
        '- Entweder, es wird versucht, durch Start der Exe eine neue Instanz der Anwendung zu
        '  starten
        '- oder durch Doppelklick auf eine Datei wird versucht, diese Datei zu ffnen
        '- oder innerhalb des Anwendungs-Fensters soll eine neue Datei geffnet oder erstellt 
        '  werden

        'fr "Neue Datei" ist DateiName leer, fr eine existierende Datei wird hier der Pfad 
        'zur gespeicherten Datei bergeben

        ' Feststellen, ob bereits ein Fenster fr diese Datei geffnet ist
        If Not String.IsNullOrEmpty(DateiName) Then
            'Auflistung aller geffneten Formulare durchgehen, die der Anwendung zugeordnet sind.
            For Each xfrm As System.Windows.Forms.Form In Application.OpenForms
                If TypeOf (xfrm) Is frm_Main Then
                    Dim GeoeffneteForm As frm_Main = xfrm
                    If String.Compare(GeoeffneteForm.DateiName, DateiName, True) = 0 Then
                        ' Bring form to top
                        GeoeffneteForm.Activate()
                        'Wenn ein Fenster mit diesem Dateinamen bereits existiert, 
                        'dieses in den Vordergrund bringen
                        Return GeoeffneteForm
                    End If
                End If
            Next
        End If


        ' Ansonsten eine neue Form, ggf. mit Dateinamen, anzeigen
        Dim frm As New frm_Main
        frm.OpenFile(DateiName)
        frm.Show()
        ' in den Vordergrund bringen
        frm.Activate()
        Return frm

    End Function

    Sub OpenFile(ByVal fileName As String)


        If Not String.IsNullOrEmpty(fileName) Then
            m_Personen = New Personenliste(fileName)
            Me.Text &= " (" & IO.Path.GetFileNameWithoutExtension(fileName) & ")"
        Else
            m_Personen = New Personenliste
            LeereDateienZahl += 1
            Dim NeuerDateiName As String = "Neues Dokument " + LeereDateienZahl.ToString()
            m_Personen.Pfad = NeuerDateiName
            Me.Text &= " (" & NeuerDateiName & ")"
        End If

        'Erst hier erfolgt die weitere Initialisierung aller Formular-Inhalte 
        'in Abhngigigkeit vom Inhalt der Datei
        LoadStartValues()

    End Sub

    Private Sub LoadStartValues()
        Personenliste_Lesen()
        If ListView1.Items.Count > 0 Then
            ListView1.Items(0).Selected = True
        End If

        m_undoManager = New UndoManager(1000)
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        'Auch am Konstruktor mssen ein paar nderungen vorgenommen werden:
        My.Application.AddTopLevelForm(Me)
        My.Application.AddWindowMenu(Me.WindowsMenu)

    End Sub

#Region " Menelemente "

    Private Sub NeuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuToolStripMenuItem.Click, NeuToolStripButton.Click
        'Entspricht "Datei->Neu"
        Dim Liste As New List(Of String)
        Dim readOnlyListe As New ReadOnlyCollection(Of String)(Liste)
        My.Application.CreateTopLevelWindow(readOnlyListe)
    End Sub

    Private Sub ffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ffnenToolStripMenuItem.Click, ffnenToolStripButton.Click
        'Entspricht "Datei->ffnen"

        Dim Dlg As New OpenFileDialog

        Dlg.Filter = "Personenliste-Dateien (*.pslst)|*.pslst"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True

        If Dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            frm_Main.CreateTopLevelWindow(Dlg.FileName)
        End If

    End Sub

    Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click, SpeichernToolStripButton.Click
        'Entspricht "Datei->Speichern"
        EinfachSpeichernErfolgreich()
    End Sub

    Private Sub SpeichernunterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernunterToolStripMenuItem.Click
        'Entspricht "Datei->Speichern unter"
        Speichern_Unter_Erfolgreich()
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        'Entspricht "Datei->Beenden"
        'Es wird versucht, das Formular zu schlieen, die Frage nach dem Speichern wird 
        'im FormClosing-Handler gestellt
        Me.Close()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        'wenn das Formular geschlossen wird, 
        'Frage, ob gespeichert werden soll
        'Beim Abbruch des Speicherns bleibt das Formular offen
        If Not SpeichernMitFrageErfolgreich() Then
            e.Cancel = True
        End If
    End Sub

#End Region

#Region " Speichern "

    Private Function SpeichernMitFrageErfolgreich() As Boolean
        'Diese Funktion liefert nur False, wenn das Speichern abgebrochen wird
        'ansonsten wird entweder gespeichert oder darauf verzichtet
        If m_Personen.Geaendert Then
            Dim Result As DialogResult = MessageBox.Show("nderungen speichern?", _
           "Personensammlung", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
            If Result = Windows.Forms.DialogResult.Yes Then
                If m_Personen.Pfad.IndexOf("\") > -1 Then
                    m_Personen.Speichern()
                    Return True
                Else
                    'Wenn die Datei noch nie gespeichet wurde, wird Speichern unter..
                    'aufgerufen
                    Return Speichern_Unter_Erfolgreich()
                End If
            ElseIf Result = Windows.Forms.DialogResult.No Then
                Return True
            ElseIf Result = Windows.Forms.DialogResult.Cancel Then
                Return False
            End If
        Else
            Return True
        End If
    End Function

    Private Function EinfachSpeichernErfolgreich() As Boolean
        If m_Personen.Geaendert Then
            If m_Personen.Pfad.IndexOf("\") > -1 Then
                'Diese Datei existiert bereits
                m_Personen.Speichern()
                Return True
            Else
                'Diese Datei wurde noch nie gespeichert,
                'also Speichern unter... aufrufen
                Return Speichern_Unter_Erfolgreich()
            End If
        Else
            Return True
        End If
    End Function

    Private Function Speichern_Unter_Erfolgreich() As Boolean
        Dim Dlg As New SaveFileDialog

        Dlg.Filter = "Personenliste-Dateien (*.pslst)|*.pslst"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True
        Dlg.AddExtension = True
        Dlg.OverwritePrompt = False
        If m_Personen.Pfad.IndexOf("\") > -1 Then
            'Diese Datei existiert bereits
            Dlg.FileName = m_Personen.Pfad
        Else
            'Diese Datei wurde noch nie gespeichert
            Dlg.FileName = Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\" & m_Personen.Pfad
        End If

        If Dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then

            If m_Personen.Pfad <> Dlg.FileName Then
                For Each frm As System.Windows.Forms.Form In Application.OpenForms
                    If TypeOf (frm) Is frm_Main Then
                        Dim GeoeffneteForm As frm_Main = frm
                        If String.Compare(GeoeffneteForm.DateiName, Dlg.FileName, True) = 0 Then
                            MessageBox.Show("Es ist bereits eine Datei mit diesem Namen geffnet." & vbCrLf & _
                            "Bitte schlieen Sie dieses Dokument oder whlen Sie einen anderen Datenamen aus.", My.Application.Info.AssemblyName, MessageBoxButtons.OK, MessageBoxIcon.Information)
                            Return False
                            Exit For
                        End If
                    End If
                Next
            End If

            m_Personen.Pfad = Dlg.FileName
            m_Personen.Speichern()
            Me.Text = My.Application.Info.AssemblyName & " (" & IO.Path.GetFileNameWithoutExtension(m_Personen.Pfad) & ")"
            Return True
        End If
        Return False
    End Function

#End Region

#End Region


End Class
